unit uVererbung2;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls;

type
  TWuerfel = class
  private
    FZahl : integer;
  public
    procedure SetZahl(a : integer);
    function GetZahl : integer;
  end;

  TW4 = class(TWuerfel)
  public
    procedure wuerfele;
  end;

  TW6 = class(TWuerfel)
  public
    procedure wuerfele;
  end;

  TForm1 = class(TForm)
    bW4werfen: TButton;
    bW6werfen: TButton;
    bW4aktuell: TButton;
    bW6aktuell: TButton;
    lAugen: TLabel;
    bWuerfele: TButton;
    bTypAktuell: TButton;
    lAktuell: TLabel;
    lAktuellTyp: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure bW4werfenClick(Sender: TObject);
    procedure bW6werfenClick(Sender: TObject);
    procedure bW4aktuellClick(Sender: TObject);
    procedure bW6aktuellClick(Sender: TObject);
    procedure bWuerfeleClick(Sender: TObject);
    procedure bTypAktuellClick(Sender: TObject);
  private
    w4 : TW4;
    w6 : TW6;
    wAktuell : TWuerfel;
  public
    { Public-Deklarationen }
  end;

var
  Form1: TForm1;

implementation
{$R *.dfm}

procedure TWuerfel.SetZahl(a : integer);
begin
  FZahl := a;
end;

function TWuerfel.GetZahl : integer;
begin
  result := FZahl;
end;

procedure TW4.wuerfele;
begin
  setZahl(Random(4)+1);
end;

procedure TW6.wuerfele;
begin
  setZahl(Random(6)+1);
end;


procedure TForm1.FormCreate(Sender: TObject);
begin
  Randomize;
  w4 := TW4.Create; w4.wuerfele;
  w6 := TW6.Create; w6.wuerfele;
  wAktuell := w6;
  lAktuell.caption := 'W6 ist aktueller Wrfel';
end;


procedure TForm1.FormDestroy(Sender: TObject);
begin
  w4.Free; w6.Free;
end;

procedure TForm1.bW4werfenClick(Sender: TObject);
begin
  w4.wuerfele;
  lAugen.Caption := IntToStr(w4.GetZahl);
end;

procedure TForm1.bW6werfenClick(Sender: TObject);
begin
  w6.wuerfele;
  lAugen.Caption := IntToStr(w6.GetZahl);
end;

procedure TForm1.bW4aktuellClick(Sender: TObject);
begin
  wAktuell := w4;
  lAktuell.caption := 'W4 ist aktueller Wrfel';
end;

procedure TForm1.bW6aktuellClick(Sender: TObject);
begin
  wAktuell := w6;
  lAktuell.caption := 'W6 ist aktueller Wrfel';
end;

procedure TForm1.bWuerfeleClick(Sender: TObject);
begin
  if wAktuell = w4 then TW4(wAktuell).wuerfele;
  if wAktuell = w6 then w6.wuerfele;

  lAugen.Caption := IntToStr(wAktuell.GetZahl);
end;

procedure TForm1.bTypAktuellClick(Sender: TObject);
begin
  if WAktuell is TW4 then lAktuellTyp.Caption := 'TW4';
  if WAktuell is TW6 then lAktuellTyp.Caption := 'TW6';
end;

end.
